/*************************************\
| MLC AFX by Jacek (4nic8) Malinowski |
+-------------------------------------+
| contact: 4nic8@casiocalc.org        |
\*************************************/


//#include <conio.h>
#include <stdlib.h>

//#include <dos.h>

#include "libs\utils.c"

#include "libs\gxlib10.h"
#include "libs\gxlib10.c"
#include "libs\gxlibcod.c"

#define VXS 0
#define VXM 128

#include "libs\gx_plug.c"

#include "libs\font_gx.c"

#include "libs\testkey.c"

#include "abc.c"
#include "Memzones.c"

#include "mlc.h"

uchar scr_b123[3][1024];

//#define DEBUG1

//#define DEBUG2 /* shows tokenized code: */
//#define DEBUG3
//#define DEBUG4

//#define DEBUG_MEM

//#define DEBUG5

void halt();
void close_go_menu();

unsigned char name[20];/* Name of MLC file */
uchar far *code;/* pointer to MLC tokenized code */
uchar far *source;/* pointer to MLC source */
uchar far *mlc_save;
uint code_size; /* size of MLC file */

uchar over=0; /* when over==1 MLC program stops*/

void set_go_menu();

#include "token.c"
#include "interpr.c"

//#include "shell.c"

#if defined DEBUG3
	char key=0;
	uint pom;
	syntax syx;
#endif

void halt(){
	over=1;	
}


#ifdef __cplusplus
    #define __CPPARGS ...
#else
    #define __CPPARGS
#endif

void menu(){
	close_go_menu();
	halt();
}

void interrupt ( *oldhandler)(__CPPARGS);

void interrupt handler(__CPPARGS)
{
	static bool key=false;
	oldhandler(); 
	if (testkey(K_AC))
		over=1;//menu();
	if(testkey(K_F)) { if(!key) { contplus(); key = true; } }
		else if(testkey(K_L)) { if(!key) { contmoins(); key = true; } }
		else key=false;
    
}
void set_go_menu(){
	setvect(0x1C, handler);	
}

void old_int(){
	oldhandler = getvect(0x1C);
}

void close_go_menu(){
	setvect(0x1C, oldhandler);	
}


uint free_m(){
	uint fmem;
	asm{
		push ax
		push bx
		mov bx,0xafff
		mov ax,0x48
		int 0x21
		mov fmem,bx
		pop ax
		pop bx
	}
	return fmem;
}

void execute(char pathp[]){ //By 2072
    char command[128];          //buffer for the command line
    char *args[64];             //table of arguments
    int i;
    int numberofargs    =0;     //no comment
    int a               =0;
	 int cline_size;             //size of the command line
	 cline_size=strlen(pathp);   //cline_size is set
	 if (cline_size > 128)       //Error if the command line size is more than 128
		  return;
	 //This, below, scan the command line to find space characters
    for (i=0; i <= cline_size; i++) {
	if (pathp[i]!=(char)32) {               //if there is no space
	    if (a==0)                           //if it is the first character of the arg
		args[numberofargs]=&command[i]; //copy the address of the first arg
	    command[i]=pathp[i];                //copy the arg in command
				a++;                                //a is increased till a space is found
	} else if (a > 0 && args[numberofargs][a - 1]!=(char)32) {      //if a space is found after
									//an argument and if the
									//previous character wasn't a
									//space
				command[i]='\0';    //this end the argument
	    numberofargs++;     //a new argument has been found
	    a=0;                //reset the index of character of the argument
		  }
	 }
	 args[numberofargs + 1]=NULL;    //This is for the last argument
	 execv(args[0], args);   //execute the progs with the argument list
	 return;
}

void main(int argc, char **argv){	
	
	uint tok_size;	
	struct memory_zone fp_c,fp_t;
	int i,ix;			
	char ln[20];
	struct memory_zone fp_sv;
	char sv_name[20];

	//////////
	/*
	uchar bp[SPR16x16_SIZE];
	uchar t6x6[16][16]=
	{{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3},
	{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4},
	{4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3},
	{4,4,4,4,4,4,4,4,4,4,4,4,2,2,2,3},
	{4,4,4,4,4,4,4,4,4,4,4,4,2,4,4,3},
	{4,4,4,4,4,4,4,4,4,4,4,4,2,4,4,3},
	{4,4,4,4,4,4,4,4,4,4,4,4,2,4,4,3},
	{4,4,4,4,4,4,4,4,4,4,4,4,2,4,4,3},
	{4,4,4,4,4,4,4,4,4,4,4,4,2,4,4,3},
	{4,4,4,4,4,4,4,4,4,4,4,4,2,4,4,3},
	{4,4,4,4,4,4,2,4,2,2,2,4,4,4,4,3},
	{4,4,4,4,4,4,4,4,4,4,4,4,4,3,4,3},
	{4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,3},
	{4,4,4,4,4,4,4,4,4,4,4,3,3,4,4,3},
	{4,4,4,4,4,4,4,4,4,3,3,4,4,3,4,4},
	{2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2}};*/
	//////////
#if defined DEBUG_MEM
	clrscr();
	 printf("The difference between the highest allocated block and\n");
	 printf("the top of the heap is: %u bytes\n", (unsigned) coreleft());
	//printf("Free : %ub",allocmem(0xafff,pcode));
	if (getch()==0) getch();
#endif

#if !defined DEBUG2 && !defined DEBUG4 && !defined DEBUG_MEM
		inter(0);
		gxSetMode(true);		
#endif
	/*
	makeCode((uchar*)t6x6,16,16,bp);
	gxSprite(10,10,bp,GX_SPR_MASK_CLIP);
	gxRefresh();		
	//for (;;);*/
	
	memcpy(name,argv[1],9);
	old_int();
	set_go_menu();
    sv_name[0]='~';
			for (i=1;i<20;i++) sv_name[i]=name[i-1];
			sv_name[8]='\0';
			if (search_mem_zone(1,sv_name,&fp_sv)==-1) 
				create_mem_zone(1,sv_name,MLC_SAVE_FILE,CREATE_ZONE);

			if (search_mem_zone(1,name,&fp_c)!=-1) 
			{		
				/* tokenized file */
				if (search_mem_zone(1,TEMP_FILE,&fp_t)!=-1) 
				{
					create_mem_zone(1,TEMP_FILE,fp_t.b_size,DELETE_ZONE);
				}
				create_mem_zone(1,TEMP_FILE,fp_c.b_size,CREATE_ZONE);
				if (search_mem_zone(1,TEMP_FILE,&fp_t)==-1) error_msg2("Out of RAM memory","");		
				
				/* pointer to tokenized code */
				code = (unsigned char far *) MK_FP(fp_t.b_segment,fp_t.b_offset+21);
				
				code_size=(uint)fp_c.b_size-24;
				search_mem_zone(1,name,&fp_c);
				/* pointer to source code */
				source = (unsigned char far *) MK_FP(fp_c.b_segment,fp_c.b_offset+21);

				if (search_mem_zone(1,sv_name,&fp_sv)==-1) error_msg2("Out of RAM memory","");		
				change_password(&fp_sv,"mlcsave");
				/* pointer to save file code */
				mlc_save = (unsigned char far *) MK_FP(fp_sv.b_segment,fp_sv.b_offset+21);
				
				gxClearBuff();
				OutStrTI(1,1,"MLC Copyrights(c) 2004-2005",3,ti);
				OutStrTI(1,7,"Epic Programming Studios",3,ti);
				OutStrTI(1,13,"MLC AFX Copyrights(c) 2004-2005",3,ti);
				OutStrTI(1,19,"Jacek (4nic8) Maliniowski",3,ti);
				OutStrTI(1,30,"tokenizing... (v. 1.2)",2,ti);
				gxRefresh();
				tokenizer(fp_c.b_size-24,&tok_size);
		
				take_functions(tok_size);		
				gxClearBuff();
				gxRefresh();		
				
				start_inter();
				if (argc<2) exit(0);
				for (i=0; i<6; i++)
				{	
					sprintf(ln,"%c:\\%s",'L'+i,argv[2]);
					execute(ln);
				}

			}
			else
			{
				error_msg2(name,"No input file");
			}

	//run_shell(name);
	
	
}