
#include <dos.h>
#include <process.h>
#include <io.h>
#include <stdio.h>
#include <stdlib.h>

#include "libs\utils.c"

#include "libs\gxlib10.h"
#include "libs\gxlib10.c"
#include "libs\gxlibcod.c"

#include "Memzones.c"
#include "mzlist.c"
#define VXS 0
#define VXM 128
#include "libs\gx_plug.c"

#include "libs\font_gx.c"

#include "libs\testkey.c"

#include "abc.c"
#include "f_bfont.c"


#define MAX_F 200

struct memory_zone file[MAX_F];
int files=0;
int val;
int cur_zone=1;
char mlc[5];

void execute(char pathp[]){ //By 2072
    char command[128];          //buffer for the command line
    char *args[64];             //table of arguments
    int i;
    int numberofargs    =0;     //no comment
    int a               =0;
	 int cline_size;             //size of the command line
	 cline_size=strlen(pathp);   //cline_size is set
	 if (cline_size > 128)       //Error if the command line size is more than 128
		  return;
	 //This, below, scan the command line to find space characters
    for (i=0; i <= cline_size; i++) {
	if (pathp[i]!=(char)32) {               //if there is no space
	    if (a==0)                           //if it is the first character of the arg
		args[numberofargs]=&command[i]; //copy the address of the first arg
	    command[i]=pathp[i];                //copy the arg in command
				a++;                                //a is increased till a space is found
	} else if (a > 0 && args[numberofargs][a - 1]!=(char)32) {      //if a space is found after
									//an argument and if the
									//previous character wasn't a
									//space
				command[i]='\0';    //this end the argument
	    numberofargs++;     //a new argument has been found
	    a=0;                //reset the index of character of the argument
		  }
	 }
	 args[numberofargs + 1]=NULL;    //This is for the last argument
	 execv(args[0], args);   //execute the progs with the argument list
	 return;
}

int name_test(char *x, char *y, int dl){
	int i;
	for (i=0;i<dl;i++)
	{
     if (x[i]!=y[i])	
	   return 1;
	 if (x[i]=='\0') return 0;
	}
   return 0;
}

void read_f_list(void)
{
//  if ((file=(struct memory_zone *)malloc(MAX_F*sizeof (struct memory_zone)))==NULL)
//	    error_msg("Out of memory!!!","SHELL",0);
  files=0;
  val=b_findfirst(&file[files],1); 
  
  while(val==1) 
  {
     read_mem_zone(&file[files],mlc,0,4);
	 if (name_test(mlc,"MLC:",4)==0){
		 memcpy(&file[files+1],&file[files],sizeof(file[files]));
		files++;
	 }
     val=b_findnext(&file[files]);
  }
//  if (file>0) files--;
}

void error_msg_shell(){
	gxSetMode(false);
	inter(1);
	//close_go_menu();
	clrscr();
	printf("ERROR\n\n");
	printf("There isn't any MLC\nfile!\n\nPress F1 to exit");
	twaitkey(G_F1);
	exit(0);
}

extern uchar epic[];

#define FINP 6
#define TEXTS 48
#define YSPC 9
void run_shell(){	
	uchar *text[]={
		" #  # #    ### ",//0
		" #### #   #    ",
		" #  # #   # ;-)",
		" #  # #   #    ",
		" #  # ###  ### ",
		"      by",
		"EpicProgramming",
		"--->STUDIOS<---",
		"",
		"    CREDITS:",
		"",
		"4NIC8 [AFX,PC,",
		"TI89/92+,  AFX",
		"sprites editor]",
		"",
		"Burnt [TI85/86]",
		"Madskilz[TI83+]",
		"The Unknown One",
		"",
		"CrimsonCasio[PC",
		"sprites editor,",
		"documentation]",
		"",
		"Deimos [tester,",
		"     MLC games]",
		"",
		"Dysfunction",
		"[ideas support]",
		"",
		"SPECIAL THANKS:",
		"",
		"Orwell [gxlib]",
		"",
		"2072 [memzones]",
		"",
		"Swifter[scroll]",
		"",
		"",
		"    CONTACT:",
		"",
		"   4NIC8@WP.PL",
		"",
		"",
		" #  # #    ### ",//0
		" #### #   #    ",
		" #  # #   # ;-)",
		" #  # #   #    ",
		" #  # ###  ### "
	};
	int i,p,ac=0;
	int txty=20;
	uchar info=0;
	static bool key=false;
	struct memory_zone fp;
	uint tok_size;	
	struct memory_zone fp_c,fp_t;
	struct memory_zone fp_sv;
	FILE *ffp;
	char sv_name[20];
	char ln[50];

	read_f_list();	
	if (files==0) error_msg_shell();
	p=0;
	for (;;)
	{
		
		/* scrolling text system */
		if (info)
		{
			gxClearBuff();
			for (i=0;i<TEXTS;i++){
				if (YSPC*i+txty>0 && YSPC*i+txty<63)
				OutStr(50,YSPC*i+txty,text[i],3,bfont);
			}
			txty--;
			if	 (txty<-YSPC*TEXTS+66) txty=20;
		}
		else
		{
			gxDrawBmp(epic);			
		}
		
		frect(0,0,127,8,1);
		rect(0,0,127,63,2);		
		OutStr(22,1,"-=> MLC SHELL <=-",0,bfont);		
		frect(1,10+ac*8,45,17+ac*8,2);
		line(46,9,46,63,2);
		for (i=0;i<FINP;i++)
		{
			if (FINP*p+i<files) if (ac==i) OutStr(4,10+i*8,file[FINP*p+i].b_name,0,bfont);
							else OutStr(4,10+i*8,file[FINP*p+i].b_name,2,bfont);
		}

		gxRefresh();
		
		if (!info) wait(15);
		if(testkey(K_F1)) { if(!key) {key=true; info=1-info; } }		
		else key=false;

		if (testkey(K_UP)){
				ac--;
				if (ac<0) {p--; ac=FINP-1;}
				if (p<0) { p=0; ac=0;}
		}
		if (testkey(K_DOWN))
		{
			
				ac++;
				if (ac+FINP*p>=files) ac--;
				if (ac>=FINP) {p++; ac=0;}
				if (p<0) p=0;			
		}
		if (testkey(K_ESC)){
			//close_go_menu();
			gxSetMode(false);
			inter(1);		
			/*
			if (search_mem_zone(1,TEMP_FILE,&fp)!=-1) 
			{		
				create_mem_zone(1,TEMP_FILE,fp.b_size,DELETE_ZONE);
			}
			*/
			exit(0);
		}
		if (testkey(K_EXE)){
			//sprintf(line,"%c%s%s",'L'+disk[ac_disk],":\\",files[ac_disk][ac_file[ac_disk]].name);
			emptybuf();
			gxSetMode(false);
			inter(1);
			for (i=0; i<6; i++)
			{
				sprintf(ln,"%c:\\MLCAFX.EXE %s MLCSHELL.EXE",'L'+i,file[FINP*p+ac].b_name);
				execute(ln);
			}
			
			/*execl("M:\\MLCAFX.EXE",NULL);
			execl("M:\\MLCAFX.EXE","STARS",NULL);
			execl("M:\\MLCAFX.EXE",NULL);
			/*
			if ((ffp=fopen(ln,"r"))!=NULL)
			execl(ln,file[FINP*p+ac].b_name,NULL); 
			ln[0]='M';
			if ((ffp=fopen(ln,"r"))!=NULL)
			execl(ln,file[FINP*p+ac].b_name,NULL); 
			ln[0]='N';
			if ((ffp=fopen(ln,"r"))!=NULL)
			execl(ln,file[FINP*p+ac].b_name,NULL); 
			ln[0]='O';
			if ((ffp=fopen(ln,"r"))!=NULL)
			execl(ln,file[FINP*p+ac].b_name,NULL); 
			ln[0]='P';
			if ((ffp=fopen(ln,"r"))!=NULL)
			execl(ln,file[FINP*p+ac].b_name,NULL); 
			ln[0]='Q';
			if ((ffp=fopen(ln,"r"))!=NULL)
			execl(ln,file[FINP*p+ac].b_name,NULL); 
			exit(0);*/
		}
	}	
}

void main(){
	inter(0);
	gxSetMode(true);	
	run_shell();
}

unsigned char epic[] = {
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
168,170,170,170,170,170,174,250,235,170,0,0,0,0,0,0,
84,85,85,85,85,85,221,215,85,93,0,0,0,0,0,0,
168,170,170,170,170,170,235,190,254,174,0,0,0,0,0,0,
84,85,85,85,85,85,221,223,213,93,0,0,0,0,0,0,
168,170,170,170,170,170,238,250,235,174,0,0,0,0,0,0,
84,85,85,85,85,85,85,85,85,85,0,0,0,0,0,0,
168,170,170,170,170,170,170,170,170,170,0,0,0,0,0,0,
84,85,85,85,85,85,85,85,85,85,0,0,0,0,0,0,
168,170,170,170,170,170,170,170,170,170,0,0,0,0,0,0,
84,85,85,85,85,85,85,85,85,85,0,0,0,0,0,0,
168,170,170,170,170,170,170,170,170,170,0,0,0,0,0,0,
84,85,85,85,85,85,85,85,85,85,0,0,0,0,0,0,
168,170,170,170,170,170,170,170,170,170,0,0,0,0,0,0,
84,85,85,85,85,85,85,85,85,85,0,0,0,0,0,0,
168,170,170,170,170,170,170,170,170,170,0,0,0,0,0,0,
84,85,85,85,85,85,85,85,85,85,0,0,0,0,0,0,
168,170,170,170,170,170,170,170,170,170,0,0,0,0,0,0,
84,85,85,85,85,85,85,85,85,85,0,0,0,0,0,0,
168,170,170,170,170,170,170,170,170,170,0,0,0,0,0,0,
84,85,85,85,85,85,85,85,85,85,0,0,0,0,0,0,
168,170,170,170,170,170,170,170,170,170,0,0,0,0,0,0,
84,85,85,85,85,85,85,85,85,85,0,0,0,0,0,0,
168,170,170,170,170,170,170,170,170,170,0,0,0,0,0,0,
84,85,85,85,85,85,85,85,85,85,0,0,0,0,0,0,
168,170,170,170,170,170,170,170,170,170,0,0,0,0,0,0,
84,85,85,85,85,85,85,85,85,85,0,0,0,0,0,0,
168,170,170,170,170,170,170,170,170,170,0,0,0,0,0,0,
84,85,85,85,85,85,85,85,85,85,0,0,0,0,0,0,
168,170,170,170,170,170,170,170,170,170,0,0,0,0,0,0,
84,85,85,85,85,85,85,85,85,85,0,0,0,0,0,0,
168,170,170,170,170,170,170,170,170,170,0,0,0,0,0,0,
84,85,85,85,85,85,85,85,85,85,0,0,0,0,0,0,
168,170,170,170,170,170,170,170,170,170,0,0,0,0,0,0,
84,85,85,85,85,85,85,85,85,85,0,0,0,0,0,0,
168,170,170,170,170,170,170,170,170,170,0,0,0,0,0,0,
84,85,85,85,85,85,85,85,85,85,0,0,0,0,0,0,
168,170,170,170,170,170,170,170,170,170,0,0,0,0,0,0,
84,85,85,85,85,85,85,85,85,85,0,0,0,0,0,0,
168,170,170,170,170,170,170,170,170,170,0,0,0,0,0,0,
84,85,85,85,85,85,85,85,85,85,0,0,0,0,0,0,
168,170,170,170,170,170,170,170,170,170,0,0,0,0,0,0,
84,85,85,85,85,85,85,85,85,85,0,0,0,0,0,0,
168,170,170,170,170,170,170,170,170,170,0,0,0,0,0,0,
84,85,85,85,85,85,85,85,85,85,0,0,0,0,0,0,
168,170,170,170,170,170,170,170,170,170,0,0,0,0,0,0,
84,85,85,85,85,85,85,85,85,85,0,0,0,0,0,0,
168,170,170,170,170,170,170,170,170,170,0,0,0,0,0,0,
84,85,85,85,85,85,85,85,85,85,0,0,0,0,0,0,
168,170,170,170,170,170,170,170,170,170,0,0,0,0,0,0,
84,85,85,85,85,85,85,85,85,85,0,0,0,0,0,0,
168,170,170,170,170,170,170,170,170,170,0,0,0,0,0,0,
84,85,85,85,85,85,85,85,85,85,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,85,17,0,0,0,134,210,65,9,0,0,0,0,0,0,
128,46,2,8,0,0,137,190,192,8,0,0,0,0,0,0,
128,21,84,5,4,64,201,222,92,12,0,0,0,0,0,0,
128,14,0,162,0,0,137,154,192,8,0,0,0,0,0,0,
128,7,64,65,85,80,231,215,65,14,0,0,0,0,0,0,
128,14,168,160,170,170,138,42,32,0,0,0,0,0,0,0,
128,7,84,68,20,85,69,29,0,0,0,0,0,0,0,0,
128,174,138,170,130,128,128,139,170,0,0,0,0,0,0,0,
128,255,71,68,64,85,213,223,127,0,0,0,0,0,0,0,
128,0,174,170,250,255,255,124,96,0,0,0,0,0,0,0,
128,113,120,245,255,241,5,31,192,0,0,0,0,0,0,0,
128,252,224,230,224,191,194,143,131,0,0,0,0,0,0,0,
128,253,225,29,252,255,247,247,151,1,0,0,0,0,0,0,
128,175,195,254,190,250,239,251,143,1,0,0,0,0,0,0,
0,7,199,245,95,84,229,255,7,1,0,0,0,0,0,0,
0,2,166,179,174,10,238,47,14,3,0,0,0,0,0,0,
0,0,204,245,28,1,229,95,29,71,0,0,0,0,0,0,
0,0,142,187,174,226,239,143,152,3,0,0,0,0,0,0,
84,0,28,247,92,57,231,29,17,87,0,0,0,0,0,0,
168,0,152,243,174,14,224,15,48,174,0,0,0,0,0,0,
80,0,16,247,92,229,241,29,48,87,0,0,0,0,0,0,
40,0,184,187,174,246,251,15,32,174,0,0,0,0,0,0,
84,1,48,247,92,251,247,29,96,87,0,0,0,0,0,0,
168,8,48,178,174,187,255,13,96,174,0,0,0,0,0,0,
84,21,48,247,28,93,247,13,60,87,0,0,0,0,0,0,
168,10,32,166,142,61,238,141,143,175,0,0,0,0,0,0,
84,85,113,247,204,29,228,253,129,87,0,0,0,0,0,0,
168,170,34,166,142,12,238,61,248,175,0,0,0,0,0,0,
84,85,117,247,204,28,204,1,255,87,0,0,0,0,0,0,
168,162,98,166,206,14,236,225,255,175,0,0,0,0,0,0,
84,69,117,247,76,12,204,249,127,87,0,0,0,0,0,0,
168,162,34,174,238,14,236,253,235,171,0,0,0,0,0,0,
84,81,117,247,76,28,204,255,117,87,0,0,0,0,0,0,
168,40,32,175,238,14,238,238,162,171,0,0,0,0,0,0,
84,124,49,247,92,28,204,205,177,87,0,0,0,0,0,0,
40,230,178,163,238,44,238,206,186,171,0,0,0,0,0,0,
84,99,149,247,76,28,204,197,209,85,0,0,0,0,0,0,
168,227,152,163,238,12,236,134,219,171,0,0,0,0,0,0,
212,221,217,243,76,28,204,5,207,85,0,0,0,0,0,0,
168,174,219,163,206,24,206,38,238,170,0,0,0,0,0,0,
192,31,207,241,220,24,196,95,112,85,0,0,0,0,0,0,
128,26,238,160,140,56,230,187,190,2,0,0,0,0,0,0,
0,52,244,241,156,113,246,253,95,0,0,0,0,0,0,0,
0,248,255,184,184,225,251,255,47,0,0,0,0,0,0,0,
0,240,127,21,255,195,253,215,23,0,0,0,0,0,0,0,
0,224,47,238,143,3,174,170,3,0,0,0,0,0,0,0,
0,64,85,252,255,255,7,84,0,0,0,0,0,0,0,0,
0,0,160,248,251,255,7,10,0,0,0,0,0,0,0,0,
0,0,0,241,1,244,5,1,0,0,0,0,0,0,0,0,
0,0,0,170,2,160,130,0,0,0,0,0,0,0,0,0,
0,0,0,84,0,0,64,0,0,0,0,0,0,0,0,0,
0,0,0,0,8,128,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
212,10,70,85,85,85,215,215,117,94,0,0,0,0,0,0,
108,193,189,162,170,170,171,214,110,170,0,0,0,0,0,0,
84,239,33,82,83,21,253,159,95,93,0,0,0,0,0,0,
232,161,234,24,191,170,187,190,250,170,0,0,0,0,0,0,
84,92,181,182,170,141,254,218,245,95,0,0,0,0,0,0,
168,163,66,74,85,85,37,157,202,170,0,0,0,0,0,0,
84,92,43,185,235,170,26,67,85,85,0,0,0,0,0,0,
168,83,37,85,41,42,42,62,85,170,0,0,0,0,0,0,
84,84,157,145,181,138,106,97,21,85,0,0,0,0,0,0,
168,175,90,85,165,170,170,171,186,170,0,0,0,0,0,0,
84,68,149,90,21,71,91,117,85,85,0,0,0,0,0,0,
168,171,59,139,187,74,169,58,236,171,0,0,0,0,0,0,
84,86,87,118,81,85,77,73,77,85,0,0,0,0,0,0,
168,90,170,169,107,165,186,170,50,170,0,0,0,0,0,0,
212,93,20,91,180,171,94,85,93,87,0,0,0,0,0,0,
168,169,139,232,90,165,160,218,168,174,0,0,0,0,0,0,
92,85,55,27,231,214,94,165,208,177,0,0,0,0,0,0,
188,170,104,230,88,185,162,120,42,174,0,0,0,0,0,0,
40,85,195,25,167,84,84,199,252,168,0,0,0,0,0,0,
84,170,110,174,88,168,186,248,170,83,0,0,0,0,0,0,
172,85,221,73,167,94,68,71,69,172,0,0,0,0,0,0,
212,171,2,230,88,171,166,184,250,83,0,0,0,0,0,0,
168,84,221,93,7,84,89,71,21,172,0,0,0,0,0,0,
84,167,170,239,88,106,162,170,186,83,0,0,0,0,0,0,
168,74,69,16,199,177,76,85,81,173,0,0,0,0,0,0,
84,181,186,251,184,202,176,106,58,82,0,0,0,0,0,0,
168,170,6,4,23,68,95,85,87,173,0,0,0,0,0,0,
84,85,249,251,232,186,160,138,162,82,0,0,0,0,0,0,
168,170,2,4,87,71,117,85,84,173,0,0,0,0,0,0,
84,89,185,251,40,168,138,138,170,82,0,0,0,0,0,0,
168,146,10,12,215,87,117,85,213,169,0,0,0,0,0,0,
84,93,253,243,24,186,138,170,54,86,0,0,0,0,0,0,
168,172,10,4,247,71,119,85,138,169,0,0,0,0,0,0,
84,214,187,242,24,168,136,59,125,86,0,0,0,0,0,0,
168,133,212,29,231,71,119,86,86,169,0,0,0,0,0,0,
212,43,41,254,24,218,136,169,161,84,0,0,0,0,0,0,
168,213,122,1,247,71,117,30,31,171,0,0,0,0,0,0,
212,136,163,254,24,186,138,169,172,84,0,0,0,0,0,0,
40,68,22,5,215,81,117,118,117,170,0,0,0,0,0,0,
212,219,172,252,184,170,168,203,171,85,0,0,0,0,0,0,
60,197,117,7,101,117,31,49,213,42,0,0,0,0,0,0,
40,173,171,251,250,162,168,46,105,169,0,0,0,0,0,0,
84,219,81,4,69,21,85,22,181,85,0,0,0,0,0,0,
168,34,42,39,238,170,174,170,154,170,0,0,0,0,0,0,
84,69,149,202,85,21,83,109,77,85,0,0,0,0,0,0,
168,138,154,128,58,190,88,213,172,170,0,0,0,0,0,0,
84,149,42,83,85,85,93,171,85,85,0,0,0,0,0,0,
168,170,74,166,164,168,170,181,170,170,0,0,0,0,0,0,
84,85,85,76,116,89,211,84,85,85,0,0,0,0,0,0,
168,170,234,85,173,90,105,174,170,170,0,0,0,0,0,0,
84,85,85,163,85,213,53,85,85,85,0,0,0,0,0,0,
168,170,170,170,162,42,170,170,170,170,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };

