/* Memory Zones Library Add-On by Superna
   Please Include Original Mem Zones Library
   Copyright 2072 MemZones Lib 2003 */


/*
  Comment utiliser les Fonctions FindFirst et FindNext
  Utilisation de ces fonctions comme l'exploration des fichiers

  * Exemple simple pour lister les fichiers de la zone 3 :
  //Debut de l'exemple
  #include <stdio.h>
  #include <conio.h>
  #include "memzones.c"
  #include "mzlist.c"

  void main(void) {
        struct memory_zone bf;
        int nb_file=0;
        int val;

        val=b_findfirst(&bf,3); //Lancement de l'exploration
        while(val==1) {
                gotoxy(1,1);
                printf("Fichier n%i :\n",nb_file);
                printf("Filename : %s\n",bf.b_name);
                printf("File Size : %i\n",bf.b_size);
                printf("Press a key...");
                if(getch()==0) getch();
                val=b_findnext(&bf);
                nb_file++; }
        return; }
   //Fin de L'exemple
   * Exemple qui liste toute les zones
   //Debut de l'exemple
   #include <stdio.h>
   #include <conio.h>
   #include "memzones.c"
   #include "mzlist.c"

   void main(void) {
        struct memory_zone bf;
        int nb_file=0;
        int val;
        int cur_zone=1;
        printf("Zone Courante : %i",cur_zone);
        if(getch()==0) getch();
        val=b_findfirst(&bf,1); //Lancement de l'exploration
        while(val==1) {
         suite:
                clrscr();
                printf("Fichier n%i :\n",nb_file);
                printf("Filename : %s\n",bf.b_name);
                printf("File Size : %i\n",bf.b_size);
                printf("Press a key...");
                if(getch()==0) getch();
                val=b_findnext(&bf);
                nb_file++; }
        if(val==-2) {   //On saute de zone
                cur_zone=bf.b_ztype;
                clrscr();
                printf("Zone Courante : %i",cur_zone);
                if(getch()==0) getch();
                goto suite; }
        return; }
    //Fin de L'exemple
    
    Explication sur le retour des Fonctions :
                Les fonctions retournent soit 1, -1 ou -2.
                1 Signifie qu'il y a un fichier disponible
                -2 Signifie qu'il y a un fichier disponible
                   mais sur la zone suivante
                -1 signifie qu'il n'y a plus de fichiers aprs
     
     Note: Vous pouvez alors ecrire/lire dans le fichier basic
           trouve par ces fonctions, la structure modifiee est
           ainsi compatible avec MemZone 1.02

        Ces Fonctions ont ete ecrites par Superna pour DirXplor
        et le Projet Xlectron, vous pouvez vous en servir a
        la seule condition d'y afficher mon nom dans les remerciements
*/

int b_findfirst(struct memory_zone * file,unsigned short type){
	char far * start;
	//u_int uds;
	start=tell_mem_zone_seg(type);
	//Debut de la memoire Casio
	file->b_segment=FP_SEG(start);
	file->b_offset=FP_OFF(start);
	//on prends la taille
	if((file->b_size=peek(file->b_segment,file->b_offset))==0)
			goto nop;
	//On va chercher le type
	file->b_ztype=peekb(file->b_segment,file->b_offset+2);
	file->b_real_size = file->b_size - (24 - (file->b_ztype!=1)*10);//real usable size of a basic file.
	file->b_inner_offset = file->b_offset + 16  - (file->b_ztype!=1)*10 + 2 + 3;//on the content of the prog  (8 + 8 + 2)
	//et le nom
	//asm mov ds,uds;
	movedata(file->b_segment,file->b_offset+3,_DS,(unsigned)file->b_name,8);
        file->b_name[8]='\0';//NULL;
        if(file->b_ztype!=type) goto next;
//On l'a le premier bougre
return 1;
nop:
//ah ben en a pu
return -1;
next:
//Ben la on change de type, on peut toujours continuer
return -2;
}

char b_findnext(struct memory_zone * file){
        int oldtype=file->b_ztype;
        //On est sur le nouveau fichier basic
        file->b_segment+=(file->b_size>>4);
        file->b_offset+=(file->b_size&0xf);
        //on prends la taille
        if((file->b_size=peek(file->b_segment,file->b_offset))==0)
                        goto nop;
        //On va chercher le type
        file->b_ztype=peekb(file->b_segment,file->b_offset+2);
        file->b_real_size = file->b_size - (24 - (file->b_ztype!=1)*10);//real usable size of a basic file.
        file->b_inner_offset = file->b_offset + 16  - (file->b_ztype!=1)*10 + 2 + 3;//on the content of the prog  (8 + 8 + 2)
        //et le nom
	movedata(file->b_segment,file->b_offset+3,_DS,(unsigned)file->b_name,8);
        file->b_name[8]='\0';//NULL;
        if(file->b_ztype!=oldtype) goto next;
//On l'a trouv le bougre
return 1;
nop:
//Ben en a pu
return -1;
next:
//Ben la on change de type, on peut toujours continuer
return -2;
}
