
//#define v_line(x,y1,y2,col) gxVLine(VXS+x, y1, y2,col>0?col+1:col)
//#define put_pix(x,y,col) gxPixel(VXS+x, y ,col>0?col+1:col)
//#define h_line(x1,y,x2,col) gxHLine(VXS+x1,VXS+x2,y, col > 0 ? col+1 :col)

void swap(int *x1, int *x2)
{
  int pom;
  pom=(*x1);
  (*x1)=(*x2);
  (*x2)=pom;
}

void backup(uchar far* tab)
{
asm {
	push ds
	les di,tab
	lds si,gxBuffer1
	mov bl,3

} boucle: asm {
	mov cx,512
	rep movsw
	add si,0x400
	dec bl
	jnz boucle
	
	pop ds
	}
}

void restore(uchar far* tab)
{
asm {
	push ds
	les di,gxBuffer1
	lds si,tab
	mov bl,3

} boucle: asm {
	mov cx,512
	rep movsw
	add di,0x400
	dec bl
	jnz boucle
	
	pop ds
	}
}


void v_line(int x, int y1, int y2, uchar col){
	if (y2<y1) swap(&y1,&y2);
	gxVLine(VXS+x, y1, y2,col>0?col+1:col);
}

void h_line(x1,y,x2,col){
	if (x2<x1) swap(&x1,&x2); 
	gxHLine(VXS+x1,VXS+x2,y, col > 0 ? col+1 :col);
}


void put_pix(int x, int y, uchar col){
	if (x>=0 && x<VXM && y>=0 && y<64)
		gxPixel(VXS+x, y ,col>0?col+1:col);
}

uchar get_pix(int x ,int y){
	static uchar c;
	if (x>=0 && x<VXM && y>=0 && y<64)
	{
		c=gxPixTest(VXS+x,y);
		if (c==1) c=0;
		return (c>1 ? c-1 : c);
	} return 0;
}

void wait(long t)
{ 
  long i;
  for (i=0; i<=t*100;i++);
}

void mlc_wait(long t)
{ 
  long i;
  for (i=0; i<=t*10;i++);
}

/*
void v_line(uchar x,uchar y1,uchar y2,uchar colour)
{
  int i;
  if (y2<y1) swap((int*)&y1,(int*)&y2);
  for (i=y1;i<=y2;i++)
    put_pix(x,i,colour);
}

void h_line(uchar x1,uchar y,uchar x2,uchar color)
{
  int i;
  if (x2<x1) swap((int*) &x1,(int*)&x2);
  for (i=x1;i<=x2;i++)
    put_pix(i,y,color);
}*/

void frect(int x1,int y1, int x2, int y2, uchar color){
	int j;
	if (x1<0 || x1>=VXM || y1<0 || y1 >63 ||
	  x2<0 || x2>=VXM || y2<0 || y2 >63) return;

	for(j=y1;j<=y2;j++)
		h_line(x1,j,x2,color);
}

void line(int x1,int y1, int x2, int y2, uchar color)
{
  long m,b; //pseudo float ;-P
  long i;
  if (x1<0 || x1>=VXM || y1<0 || y1 >63 ||
	  x2<0 || x2>=VXM || y2<0 || y2 >63) return;

  if (x1==x2 && y1==y2) return;
  if (x1==x2) { v_line(x1,y1,y2,color); return;}
  if (y1==y2) { h_line(x1,y1,x2,color); return;}  

  if (x2<x1) { swap(&x1,&x2); swap(&y1,&y2);}
  m=(100*(y2-y1))/(x2-x1);
  b=(100*y1-m*x1)/100;
  for (i=x1+1; i<=x2; i++)
	 v_line(i,(m*(i-1))/100+b,(m*i)/100+b,color);  
}

void rect(int x1,int y1, int x2, int y2, uchar colour)
{
	if (x1<0 || x1>=VXM || y1<0 || y1 >63 ||
	  x2<0 || x2>=VXM || y2<0 || y2 >63) return;

	v_line(x1,y1,y2,colour);
	v_line(x2,y1,y2,colour);
	h_line(x1,y1,x2,colour);
  h_line(x1,y2,x2,colour);
}

void gxPixInv(uint x,uint y)
{
    static int xy;
    static uchar bit0,bit1,bit2,mask,isol;
	xy = 1023-(x/8+y*16); //1023-(x/8+y*16);
	//xy = 1023-(x>>3+y<<4);
    bit0=peekb(0x1A60,xy);
    bit1=peekb(0x1AE0,xy);
    bit2=peekb(0x1B60,xy);

    isol = 128 >> (x&7);

    mask = ~isol;

        // first layer: bit0' = ~bit0

    pokeb(0x1A60,xy,(bit0 ^ isol));



        // second layer: bit1' = ~(bit1 & bit2)

    pokeb(0x1AE0,xy,(bit1 & mask) | ((~(bit1 & bit2)) & isol));



        // third layer: bit2' = (~bit1) | ((~bit0) & bit2)

    pokeb(0x1B60,xy,(bit2 & mask) | (((~bit1)|((~bit0)&bit2)) & isol));

}

void rightscroll(unsigned int x,unsigned int srcsegm,unsigned int segm)
{
  asm{
       mov si,0xF       // met 15 dans si (bloc de donnee en bas a gauche du buffer)
       xor di,di        // efface di, di=0 (bloc de donnee en bas a droite)
       mov ax,segm      // met le buffer choisi
       mov es,ax
       mov ax,srcsegm   // met dans ax le buffer source
       sub ax,segm      // ax=srcsegm-segm;
       shl ax,0x4       // ax*=16; calcule le nombre de bloc de donnee entre srcsegm et segm
       add si,ax        // met dans si la ligne du bloc de donnee de la colonne a faire apparaitre
       mov dh,0x40      // dh=64; nombre de fois a repeter la boucle(nombre de lignes d'un buffer)
       mov cx,x         // cx prends la valeur de x
       mov ax,cx        // ax prends la valeur de x
       shr ax,0x3       // ax/=8; calcul pour determiner "l'abscisse" du bloc de donnee source
       sub si,ax        // si = valeur exacte du bloc de donnee source a utiliser
       and cl,0x7       // calcul du decalage en fonction de x
       inc cl           // ajoute 1 a cl pour que le calcul soit exact
     }
  loopline:             // debut de la double boucle
  asm{
       mov bl,es:[si]   // bl = bloc de donnee source
       rol bl,cl        // decalage de bl pour faire correspondre le bit voulu au niveau du bit 0
       and bl,0x1       // efface les bits inutiles (de 1 a 7) et garde le bit 0
       mov ch,0x8       // ch=8; nombre de fois a repeter la deuxieme boucle (nombre de mots sur une ligne 8*16=64)
       add si,0x10      // si+=16; augmente le bloc de donnee source d'une ligne
     }
  loop:                 // la deuxieme boucle
  asm{
       mov ax,es:[di]   // ax = bloc de destination
       mov dl,ah        // la partie haute de ax dans dl
       rol dl,0x1       // passe le 7eme bit au bit 0 par un decalage
       and dl,0x1       // on garde le bit 0 de dl
       shl ax,0x1       // ax decale de 1
       or al,bl         // on met le contenu de dl dans al
       mov es:[di],ax   // on reaffiche le tout sur le buffer choisi (segm)
       mov bl,dl        // on met le contenu de dl dans bl
       add di,0x2       // passe au bloc de destination suivant
       dec ch           // decremente ch (ch correspond au nombre de bytes dans une ligne)
       jne loop         // continue la boucle tant que ch different de 0
       dec dh           // decremente dh (dh correspond au nombre de ligne dans un buffer)
       jne loopline
     }
}

// Decale tout le buffer choisi(segm) vers la droite et
// rajoute la colonne designee par x du buffer choisi
// (srcsegm) sur l'autre buffer choisi(segm).
// Relativement lent.
void leftscroll(unsigned int x,unsigned int srcsegm,unsigned int segm)
{
  asm{
       mov si,0x3FF     // met 1023 dans si (bloc de donnee en haut a gauche du buffer)
       mov di,0x3FE     // met 1022 dans di (bloc de donnee en haut a gauche-1)
       mov ax,segm      // met le buffer choisi
       mov es,ax
       mov ax,srcsegm   // met dans ax le buffer source
       sub ax,segm      // ax=srcsegm-segm;
       shl ax,0x4       // ax*=16; calcule le nombre de bloc de donnee entre srcsegm et segm
       add si,ax        // met dans si la ligne du bloc de donnee de la colonne a faire apparaitre
       mov dh,0x40      // dh=64; nombre de fois a repeter la boucle(nombre de lignes d'un buffer)
       mov cx,x         // cx prends la valeur de x
       mov ax,cx        // ax prends la valeur de x
       shr ax,0x3       // ax/=8; calcul pour determiner "l'abscisse" du bloc de donnee source
       sub si,ax        // si = valeur exacte du bloc de donnee source a utiliser
       and cl,0x7       // calcul du decalage en fonction de x
     }
  loopline:             // debut de la double boucle
  asm{
       mov bl,es:[si]   // bl = bloc de donnee source
       shl bl,cl        // decalage de bl pour faire correspondre le bit voulu au niveau du bit 7
       and bl,0x80      // efface les bits inutiles (de 0 a 6) et garde le bit 7
       mov ch,0x8       // ch=8; nombre de fois a repeter la deuxieme boucle (nombre de mots sur une ligne 8*16=64)
       sub si,0x10      // si-=16; descend le bloc de donnee source d'une ligne
     }
  loop:                 // la deuxieme boucle
  asm{
       mov ax,es:[di]   // ax = bloc de destination
       mov dl,al        // la partie basse de ax dans dl
       and dl,0x1       // on garde le bit 0 de dl
       ror dl,0x1       // et on le passe au 7eme bit de dl
       shr ax,0x1       // on decale ax de 1
       or ah,bl         // on met le contenu de dl dans ah
       mov es:[di],ax   // on reaffiche le tout sur le buffer choisi (segm)
       mov bl,dl        // on met le contenu de dl dans bl
       sub di,0x2       // passe au bloc de destination suivant
       dec ch           // decremente ch (ch correspond au nombre de bytes dans une ligne)
       jne loop         // continue la boucle tant que ch different de 0
       dec dh           // decremente dh (dh correspond au nombre de ligne dans un buffer)
       jne loopline
     }
}


// Decale tout le buffer choisi(segm) vers le bas et
// rajoute la ligne designee par y du buffer choisi
// (srcsegm) sur l'autre buffer choisi(segm).
// Relativement lent.
void upscroll(unsigned int y,unsigned int srcsegm,unsigned int segm)
{
  asm{
       mov ax,segm      // met le buffer choisi
       mov es,ax
       mov di,0x10      // di=16; (bloc de donnee en bas a droite au dessus de l'octet 0)
       mov si,srcsegm   // si=srcsegm
       sub si,segm      // si=(srcsegm-segm)
       sub si,y         // si=(srcsegm-segm-y)
       shl si,0x4       // si=(srcsegm-segm-y)*16
       add si,0x3F0     // si=((srcsegm-segm-y)*16)+1007 -> si pointe vers le bon octet
       mov cx,0x1F8     // nombre de fois a repeter la boucle (8*63=504)
     }
  loopline:
  asm{
       mov ax,es:[di]   // copie dans ax le mot pointe par di
       mov es:[di-0x10],ax // copie ax sur le mot en dessous du mot pointe par di
       add di,0x2       // passe au mot suivant
       dec cx           // decremente cx
       jne loopline     // tant que cx different de 0, continue la boucle
       or ch,0x8        // ch=0
       sub di,0x10      // retire 16 a di pour qu'il pointe sur le bon octet
     }
  loop:
  asm{
       mov ax,es:[si]   // copie le mot de la ligne choisie dans ax
       mov es:[di],ax   // copie ax sur le mot pointe par di
       add di,0x2       // passe au mot suivant sur le buffer choisi (segm)
       add si,0x2       // passe au mot de la ligne choisie suivant
       dec ch           // decremente ch
       jne loop         // tant que ch different de 0, continue la boucle
     }
}


// Decale tout le buffer choisi(segm) vers le haut et
// rajoute la ligne designee par y du buffer choisi
// (srcsegm) sur l'autre buffer choisi(segm).
// Relativement lent.
void downscroll(unsigned int y,unsigned int srcsegm,unsigned int segm)
{
  asm{
       mov ax,segm      // met le buffer choisi
       mov es,ax
       mov di,0x3EE     // di=1006; (bloc de donnee en haut a gauche au dessous de l'octet 1022)
       mov si,srcsegm   // si=srcsegm
       sub si,segm      // si=(srcsegm-segm)
       sub si,y         // si=(srcsegm-segm-y)
       shl si,0x4       // si=(srcsegm-segm-y)*16
       add si,0x3FE     // si=((srcsegm-segm-y)*16)+1022 -> si pointe vers le bon octet
       mov cx,0x1F8     // nombre de fois a repeter la boucle (8*63=504)
     }
  loopline:
  asm{
       mov ax,es:[di]   // copie dans ax le mot pointe par di
       mov es:[di+0x10],ax // copie ax sur le mot au dessus du mot pointe par di
       sub di,0x2       // passe au mot suivant
       dec cx           // decremente cx
       jne loopline     // tant que cx different de 0, continue la boucle
       or ch,0x8        // ch=0
       add di,0x10      // ajoute 16 a di pour qu'il pointe sur le bon octet
    }
  loop:
  asm{
       mov ax,es:[si]   // copie le mot de la ligne choisie dans ax
       mov es:[di],ax   // copie ax sur le mot pointe par di
       sub di,0x2       // passe au mot suivant sur le buffer choisi (segm)
       sub si,0x2       // passe au mot de la ligne choisie suivant
       dec ch           // decremente ch
       jne loop         // tant que ch different de 0, continue la boucle
     }
}

void scroll(int x, int y, int col){
	int i;
	x=-x;
	y=-y;
	if (x<0){
		x=-x;
		for (i=0;i<x;i++)
		{
			leftscroll(127,0x1A60,0x1A60);
			leftscroll(127,0x1AE0,0x1AE0);
			leftscroll(127,0x1B60,0x1B60);
			if (col>-1)
				v_line(0,0,63,col);
		}
	}
	else
	if (x>0){
		for (i=0;i<x;i++)
		{
			rightscroll(0,0x1A60,0x1A60);
			rightscroll(0,0x1AE0,0x1AE0);
			rightscroll(0,0x1B60,0x1B60);
			if (col>-1)
				v_line(127,0,63,col);

		}
	}
	if (y<0){
		y=-y;
		for (i=0;i<y;i++)
		{
			upscroll(63,0x1A60,0x1A60);
			upscroll(63,0x1AE0,0x1AE0);
			upscroll(63,0x1B60,0x1B60);
			if (col>-1)
				h_line(0,0,127,col);
		}
	}else
	if (y>0){
		for (i=0;i<y;i++)
		{
			downscroll(0,0x1A60,0x1A60);
			downscroll(0,0x1AE0,0x1AE0);
			downscroll(0,0x1B60,0x1B60);
			if (col>-1)
				h_line(0,63,127,col);
		}
	}
}