#define MASK			4
#define WHITE			0
#define LIGHTGRAY		99
#define GRAY			1
#define DARKGRAY		2
#define BLACK			3

	// codage du sprite en mode gxLib 1.0
int makeCode(uchar* image, int width, int height, uchar* output)
{
	short pxldebut=0;
	int i;
	int largeur = width, hauteur = height;
	int l = largeur;
	int size;
	int h;
	uchar oa1, oa2, oa3;
	uchar ob1, ob2, ob3;
	uchar o1, o2, o3;
	uchar* code = output;
	uchar* Code = output+4;

	if(l%8) l=l-l%8+8;	// si la largeur n'est pas multiple de 8

	size = 4								// origine+hauteur+fin du sprite
			+ (l/16)*(1+6*hauteur)			// blocs de 16 pixels
			+ ((l%16)==8)*(1+3*hauteur);	// bloc de 8 pixel si necessaire

	l=largeur;
	code[0]=0;
	code[1]=0;
	code[2]=(uchar)hauteur;
	code[3]=(uchar)largeur;

	do
	{
		if (l>8)	// bloc de 16 pixels a traiter si la largeur restante est >8
		{
			if (pxldebut) *(Code++)=16;

			for (h=0;h<hauteur;h++)
			{
				oa1 = oa2 = oa3 = 0;

				for (i=0; i<8;i++)
				{
					uchar coul = image[h*width+pxldebut+i];
					uchar trame = !((h+i)&1);

					oa1 <<= 1; oa2 <<= 1; oa3 <<= 1;

					switch(coul)
					{
					case WHITE:		 oa1 += 1;								        break;
					case MASK:		 										        break;
					case LIGHTGRAY:  oa1 += 1;					   oa3 += 1;        break;
					case GRAY:		 oa1 += trame;  oa2 += trame;  oa3 += !trame;   break;
					case DARKGRAY:   oa1 += trame;  oa2 += 1;      oa3 += trame;    break;
					case BLACK:	 	 	 	        oa2 += 1;      oa3 += 1;	    break;
					}
				}

				ob1 = 0, ob2 = 0, ob3 = 0;

				for (i=0; i<8;i++)
				{
					uchar coul = ((pxldebut+8+i < largeur) ? image[h*width+pxldebut+8+i] : 
MASK);
					uchar trame = !((h+i)&1);

					ob1 <<= 1; ob2 <<= 1; ob3 <<= 1;

					switch(coul)
					{
					case WHITE:		  ob1 += 1;								        break;
					case MASK:		 										        break;
					case LIGHTGRAY:   ob1 += 1;					    ob3 += 1;       break;
					case GRAY:		  ob1 += trame;  ob2 += trame;  ob3 += !trame;  break;
					case DARKGRAY:    ob1 += trame;  ob2 += 1;      ob3 += trame;   break;
					case BLACK:	 	 	 	         ob2 += 1;      ob3 += 1;	    break;
					}
				}

				*(Code++) = ob1;
				*(Code++) = oa1;
				*(Code++) = ob2;
				*(Code++) = oa2;
				*(Code++) = ob3;
				*(Code++) = oa3;
			}

			pxldebut+=16;
			l-=16;
		}
		else 	// bloc de 8 pixels a traiter si la largeur restante est <=8
		{
			if (pxldebut) *(Code++) = 8;

			for (h=0;h<hauteur;h++)
			{
				o1 = o2 = o3 = 0;

				for (i=0; i<8;i++)
				{
					uchar coul = ((pxldebut+i < largeur) ? image[h*width+pxldebut+i] : 
MASK);
					uchar trame = !((h+i)&1);

					o1 <<= 1; o2 <<= 1; o3 <<= 1;

					switch(coul)
					{
					case WHITE:		 o1 += 1;								     break;
					case MASK:		 										     break;
					case LIGHTGRAY:  o1 += 1;					  o3 += 1;       break;
					case GRAY:		 o1 += trame;   o2 += trame;  o3 += !trame;  break;
					case DARKGRAY:   o1 += trame;   o2 += 1;      o3 += trame;   break;
					case BLACK:	 	 	 	        o2 += 1;      o3 += 1;	     break;
					}
				}

				*(Code++) = o2;
				*(Code++) = o3;
				*(Code++) = o1;
			}

			pxldebut+=8;
			l-=8;
		}

	} while ( pxldebut < largeur );

	*(Code++) = 0;
	return size;
}