/*******************
MLC - Sprites Editor
____________________
4nic8@casiocalc.org
********************/

#include <conio.h>
#include <stdlib.h>
#include <dos.h>

#include "libs\utils.c"

#include "libs\gxlib10.h"
#include "libs\gxlib10.c"
#include "libs\gxlibcod.c"

#define VXS 0
#define VXM 128

#include "libs\gx_plug.c"

#include "libs\font_gx.c"

#include "libs\testkey.c"

#include "abc.c"
//#include "f_bfont.c"

#include "Memzones.c"
#include "mzlist.c"

#define GRID_COLOR 4
#define MARK_COLOR 0

int GRID_SIZE = 4;

#define INFO_X 64

#define C_MASK 1
#define C_0 0
#define C_1 2
#define C_2 3
#define C_3 4

#define NEXT_L_TAG 13


#define SPR8_F_SIZE 94
#define SPR6_F_SIZE 233

#define M_X 70
#define M_Y 5

uchar tbmp[16][16];

void mark(int x, int y){
	rect(x*GRID_SIZE,y*GRID_SIZE,(x+1)*GRID_SIZE,(y+1)*GRID_SIZE,MARK_COLOR);	
}

void unmark(int x, int y){
	rect(x*GRID_SIZE,y*GRID_SIZE,(x+1)*GRID_SIZE,(y+1)*GRID_SIZE,GRID_COLOR);
}

void f_rect(int x1,int y1, int x2, int y2, uchar color){
	int j;
	if (x1<0 || x1>=VXM || y1<0 || y1 >63 ||
	  x2<0 || x2>=VXM || y2<0 || y2 >63) return;

	for(j=y1;j<=y2;j++)
		gxHLine(x1,x2,j,color);
}

void fill(int x, int y, uchar col){
	f_rect(x*GRID_SIZE+1,y*GRID_SIZE+1,(x+1)*GRID_SIZE-1,(y+1)*GRID_SIZE-1,col);
	if (col!=C_MASK) gxPixel(M_X+x,M_Y+y,col);
		else gxPixel(M_X+x,M_Y+y,0);
}

#define V_Y -10
void info(){
	f_rect(65,36+V_Y,69,40+V_Y,1);
	OutStrTI(71,36+V_Y,"F5 - mask",3,ti);
	f_rect(65,42,69,46,C_0);
	OutStrTI(71,42+V_Y,"F1 - white",3,ti);
	f_rect(65,48+V_Y,69,52+V_Y,C_1);
	OutStrTI(71,48+V_Y,"F2 - l gray",3,ti);
	f_rect(65,54+V_Y,69,58+V_Y,C_2);
	OutStrTI(71,54+V_Y,"F3 - d gray",3,ti);
	f_rect(65,60+V_Y,69,64+V_Y,C_3);
	OutStrTI(71,60+V_Y,"F4 - black",3,ti);
	OutStrTI(65,66+V_Y,"+/- zoom in/out",3,ti);
}

void clear_bmp_tab(int mode,uchar col){
	int i,j;
	for (j=0;j<mode;j++)
		for (i=0;i<mode;i++)
			tbmp[i][j]=col;
}

void update(int mode){
	int i,j;
	for (j=0;j<mode;j++)
		for (i=0;i<mode;i++)
			fill(i,j,tbmp[i][j]);
}

void gui(int mode)
{
	int i,j;
	gxClearBuff();
	for (j=0;j<mode;j++)
		for (i=0;i<mode;i++){
			mark(i,j);
			unmark(i,j);
	}
/*
	for (i=0;i<mode*GRID_SIZE;i++)
		gxHLine(0,mode*GRID_SIZE,i,1);
	for (i=0;i<mode+1;i++)
		gxVLine(i*GRID_SIZE,0,mode*GRID_SIZE,GRID_COLOR);
	for (i=0;i<mode+1;i++)
		gxHLine(0,mode*GRID_SIZE,i*GRID_SIZE,GRID_COLOR);
*/
}

uchar hex(uchar byte,int type)
{
  int pom;
  if (type==0)
  {
    pom='0'+byte/16;
    if (pom-'0'>9) pom='A'+pom-'0'-10;
  }
  else
  {
    pom='0'+byte%16;
    if (pom-'0'>9) pom='A'+pom-'0'-10;
  }
  return pom;
}
#define LINE_X 65
void insert_hex(int mode,uchar *tab,uchar bmp[32][3])
{
	int i,j;
	if (mode==8)
	for (j=0;j<3;j++)
	{
		for (i=0;i<8;i++)
		{
			tab[17*j+i*2]=hex(bmp[i][j],0);
			tab[17*j+i*2+1]=hex(bmp[i][j],1);
			//tab[24*j+i*3+2]=':';
		}
		tab[17*j+16]=13;
	}
	else
	for (j=0;j<3;j++)
	{
		for (i=0;i<32;i++)
		{
			tab[LINE_X*j+i*2]=hex(bmp[i][j],0);
			tab[LINE_X*j+i*2+1]=hex(bmp[i][j],1);
			//tab[24*j+i*3+2]=':';
		}
		tab[LINE_X*j+LINE_X-1]=13;
	}
}
#define HEDER_SIZE 14
void save_bmp(int mode,uchar slot){
	char file[] = "AMLCSPRX";
	uchar b[]={128,64,32,16,8,4,2,1};
	struct memory_zone fp;
	char header[]="#BITM [NAME 8 ";
	uchar tab[LINE_X*3];
	uchar bmp[32][3];	
	int i,j;
	int pos=0;

	header[13]=13;
	if (mode==8)
	for (j=0;j<8;j++)
	{
		bmp[j][0]=0;
		bmp[j][1]=0;
		bmp[j][2]=0;
		for (i=0;i<8;i++)
		{
			if (tbmp[i][j]==C_MASK) bmp[j][2]+=b[i];
			if (tbmp[i][j]==C_1) bmp[j][0]+=b[i];
			if (tbmp[i][j]==C_2) bmp[j][1]+=b[i];
			if (tbmp[i][j]==C_3)
			{
				bmp[j][1]+=b[i];
				bmp[j][0]+=b[i];
			}

		}
	}
	else
	for (j=0;j<16;j++)
	{
		bmp[pos][0]=0;
		bmp[pos][1]=0;
		bmp[pos][2]=0;
		for (i=0;i<8;i++)
		{
			if (tbmp[i][j]==C_MASK) bmp[pos][2]+=b[i];
			if (tbmp[i][j]==C_1) bmp[pos][0]+=b[i];
			if (tbmp[i][j]==C_2) bmp[pos][1]+=b[i];
			if (tbmp[i][j]==C_3)
			{
				bmp[pos][1]+=b[i];
				bmp[pos][0]+=b[i];
			}

		}
		pos++;
		bmp[pos][0]=0;
		bmp[pos][1]=0;
		bmp[pos][2]=0;
		for (i=8;i<16;i++)
		{
			if (tbmp[i][j]==C_MASK) bmp[pos][2]+=b[i-8];
			if (tbmp[i][j]==C_1) bmp[pos][0]+=b[i-8];
			if (tbmp[i][j]==C_2) bmp[pos][1]+=b[i-8];
			if (tbmp[i][j]==C_3)
			{
				bmp[pos][1]+=b[i-8];
				bmp[pos][0]+=b[i-8];
			}

		}
		pos++;
	}
	file[7]='0'+slot;
	if (search_mem_zone(1,file,&fp)!=-1) 
			{
				create_mem_zone(1,file,fp.b_size,DELETE_ZONE);
			}
			if (mode==8)
				create_mem_zone(1,file,SPR8_F_SIZE,CREATE_ZONE);
			else
				create_mem_zone(1,file,SPR6_F_SIZE,CREATE_ZONE);
			search_mem_zone(1,file,&fp);
	insert_hex(mode,tab,bmp);
	//header[12]='0'+mode%10;
	if (mode==8) 
		header[12]='8';
	else header[12]='6';

	write_mem_zone(&fp,&header,0,HEDER_SIZE);
	if (mode==8)
		write_mem_zone(&fp,&tab,HEDER_SIZE,17*3);
	else
		write_mem_zone(&fp,&tab,HEDER_SIZE,LINE_X*3);
	
}

void save_menu(uchar mode){
	f_rect(64,0,127,20,1);
	OutStrTI(70,3,"Save to file:",3,ti);
	OutStrTI(70,10,"F1 - F6 ?",3,ti);
	gxRefresh();
	wait(100);
	for(;;){
		if (testkey(K_F1))
		{
			save_bmp(mode,1);
			break;
		}
		if (testkey(K_F2))
		{
			save_bmp(mode,2);
			break;
		}
		if (testkey(K_F3))
		{
			save_bmp(mode,3);
			break;
		}
		if (testkey(K_F4))
		{
			save_bmp(mode,4);
			break;
		}
		if (testkey(K_F5))
		{
			save_bmp(mode,5);
			break;
		}
		if (testkey(K_F6))
		{
			save_bmp(mode,6);
			break;
		}
	}
	f_rect(64,0,127,20,0);
	update(mode);
}

void edit(int mode){
	int x=0,y=0;
	uchar col=C_3;
	static bool key=false;
	//gxClearBuff();
	for(;;){
		unmark(x,y);
		if (testkey(K_UP) && y>0) y--;
		if (testkey(K_LEFT) && x>0) x--;
		if (testkey(K_DOWN) && y<mode-1) y++;
		if (testkey(K_RIGHT) && x<mode-1) x++;
		if (testkey(K_DEL)) {
			clear_bmp_tab(mode,col);
			update(mode);
		}

		if (testkey(K_F1)) col=C_0;
		if (testkey(K_F2)) col=C_1;
		if (testkey(K_F3)) col=C_2;
		if (testkey(K_F4)) col=C_3;

		if (testkey(K_F5)) col=C_MASK;

		if (testkey(K_SHIFT))
		{
			fill(x,y,col);
			tbmp[x][y]=col;
		}
		
		if (testkey(K_Y) && GRID_SIZE>2){
			GRID_SIZE--;
			gxClearBuff();
			gui(mode);	
			update(mode);
			info();
			gxRefresh();
			wait(50);
		}

		if (testkey(K_X) && GRID_SIZE<4){
			GRID_SIZE++;
			gxClearBuff();
			gui(mode);	
			update(mode);
			info();
			gxRefresh();
			wait(50);
		}

		if (testkey(K_CTRL)) wait(50);
		mark(x,y);
		gxRefresh();
		wait(20);

		if(testkey(K_F)) { if(!key) { contplus(); key = true; } }
		else if(testkey(K_L)) { if(!key) { contmoins(); key = true; } }
		else key=false;

		if (testkey(K_F6)) save_menu(mode);

		if (testkey(K_ESC)){
			//save_bmp(mode,1);
			return;

		}
			
	}
}

void main()
{
	uchar mode;
	inter(0);
	gxSetMode(true);
	for (;;)
	{
		gxClearBuff();
		OutStrTI(1,1,"Sprites Editor v 0.8",3,ti);
		OutStrTI(1,11,"F1- Sprite 8x8",3,ti);
		OutStrTI(1,21,"F2- Sprite 16x16",3,ti);
		OutStrTI(1,31,"F3- EXIT",3,ti);
		OutStrTI(1,57,"mailto: 4nic8(at)casiocalc.org",1,ti);
		gxRefresh();
		for (;;){
			if (testkey(K_F1)){
				mode=8;
				GRID_SIZE = 4;
				break;
			}
			if (testkey(K_F2)){
				mode=16;
				GRID_SIZE = 3;
				break;
			}
			if (testkey(K_F3)){
				gxSetMode(false);
				inter(1);
				exit(0);
			}
		}
		clear_bmp_tab(mode,C_MASK);	
		gui(mode);	
		update(mode);
		info();
		gxRefresh();
		edit(mode);	
	}

}