/*************************************\
| MLC AFX by Jacek (4nic8) Malinowski |
+-------------------------------------+
| contact: 4nic8@casiocalc.org        |
\*************************************/

extern t_bmp		bmp[MAX_BMPS];/* BMPs in MLC prog */

void find_line(uint l, char *line){
	uint i=0,ln=1,pom;
	for (i=0;ln<l;i++)
	{
		if (source[i]==NEXT_L_TAG || source[i]==10) ln++;
	}
	pom=i;
	for (i=0;i<40;i++){
		line[i]=source[pom+i];
		if (line[i]==NEXT_L_TAG || line[i]==10) break;
	}
	line[i]='\0';
}

void add_err(uint l){
	struct memory_zone fp;
	uint i=0,ln=1,pom;
	if (search_mem_zone(1,name,&fp)!=-1) 
	{
		if (create_mem_zone(1,name,fp.b_size+4,RESIZE_ZONE)==-2) 
		{
			printf("\nI can't add the tag  [ESC]");
			while (!testkey(K_ESC));
			/* deleting temporary files */
			if (search_mem_zone(1,TEMP_FILE,&fp)!=-1) 
			{
				create_mem_zone(1,TEMP_FILE,fp.b_size,DELETE_ZONE);
			}	
			emptybuf();	
			exit(0);
		}

		search_mem_zone(1,name,&fp);
		for (i=0;ln<l;i++)
		{
			if (source[i]==NEXT_L_TAG || source[i]==10) ln++;
		}
		pom=i;
		for (i=fp.b_size-25;i>=pom+4;i--) source[i]=source[i-4];
		i=pom;
		source[i++]='E';
		source[i++]='R';
		source[i++]='R';
		source[i]=':';
	}
}

void error_msg(uchar *msg,uchar *msg_add, uint line){
	struct memory_zone fp;
	char ln[100];
	uchar key;
	uchar go=0;
#if !defined DEBUG4
	gxSetMode(false);
	inter(1);
#endif
	close_go_menu();
	clrscr();
	find_line(line,ln);
	printf("%s\n",ln);
	printf("ERROR %u: %s %s\n",line,msg, msg_add);
	printf("Insert \"ERR:\" tag at\nerror? Y(F1)/N(F6)");
	while (go==0){
		if (testkey(K_F1)){
			add_err(line);
			go=1;
		}
		if (testkey(K_F6)) go=1;	
	}

	/* deleting temporary files */
	if (search_mem_zone(1,TEMP_FILE,&fp)!=-1) 
	{
		create_mem_zone(1,TEMP_FILE,fp.b_size,DELETE_ZONE);
	}
	
	emptybuf();	
	exit(0);
}

void error_msg2(uchar *msg,uchar *msg_add){
	struct memory_zone fp;
	char ln[100];
	uchar key;
	//uchar go=0;
#if !defined DEBUG4
	gxSetMode(false);
	inter(1);
#endif
	close_go_menu();
	clrscr();
	printf("ERROR: %s %s\n[ESC]",msg, msg_add);
	while (!testkey(K_ESC));
	

	/* deleting temporary files */
	if (search_mem_zone(1,TEMP_FILE,&fp)!=-1) 
	{
		create_mem_zone(1,TEMP_FILE,fp.b_size,DELETE_ZONE);
	}
	
	emptybuf();	
	exit(0);
}


void error_msg_pos(uint pos,  uchar *msg,uchar *msg_add){
	uint i;
	uint line=1;
	for (i=0;i<pos;i++){
		if (code[i]==NEXT_L_CODE)
			line++;
	}
	error_msg(msg, msg_add, line);
}

int syntax_test(uint x, char *y){
   int i;
   for (i=0;i<4;i++)
     if (source[x+i]!=y[i]) return 1;
   return 0;
}

int name_test(char *x, char *y, int dl){
	int i;
	for (i=0;i<dl;i++)
	{
     if (x[i]!=y[i])	
	   return 1;
	 if (x[i]=='\0') return 0;
	}
   return 0;
}

int get_syntax(uint ix, uchar *out){
	int i;
	for (i=0;i<4;i++)
		out[i]=source[ix+i];
	return 0;
}

int get_name(uint ix, uchar *out, int dl){
	int i;
	for (i=0;i<dl;i++)
	{
		if ((source[ix+i]>57 && source[ix+i]<65) || source[ix+i]<48 || source[ix+i]>90){			
			if (i>0)
			{
				out[i]='\0';
				return i;
			}		
			return 0;
		}
		out[i]=source[ix+i];
	}
	out[i]='\0';
	return i;
}

uchar hex_to_b(uchar x1,uchar x2){
	if(x1>'9') x1=x1-'A'+10;
		else
			x1-='0';
	if(x2>'9') x2=x2-'A'+10;
		else
			x2-='0';
	return x1*16+x2;
}

#define next_line() code[(*ix)++]=NEXT_L_CODE; (*line)++;
void ignor_enters(uint *i,uint *ix, uint *line ){
	while (source[(*i)]==NEXT_L_TAG)
	{
		next_line();
		(*i)++;
	}
}

#define S8x8 24
#define S16x16 96
uint read_data(uint i,uint *ix,uint *line ,uchar bmps[MAX_BMPS][MAX_NAME+1],uint bmp_ac){
	char pom[MAX_NAME+2];
	uint dln;
	int ok;
	int j,k;
	int t,p;
	uchar tmp[SPR16x16_SIZE];	
	uchar t8x8[8][8];
	uchar t6x6[16][16];
	uchar tmask;	
	next_line();
	for(;;)
	{
		ignor_enters(&i,ix,line);
		
		if (source[i]==SYNTAX_TAG && source[i+1]=='B'
			&& source[i+2]=='I' && source[i+3]=='T'
			&& source[i+4]=='M')
		{
			i+=6;			
			if (source[i]!=BMP_TAG)
				error_msg_pos(i,syntax_list[26],ER_BMP_NAME);
			dln=get_name(i+1,pom,MAX_NAME);
			for (j=0;j<bmp_ac;j++)
				if (name_test(pom,bmps[j],MAX_NAME)==0)
				{								
					break;
				}
			i+=dln+2;
			if (source[i]=='8')
			{
				/* sets parametrs for CLSN command: */
				bmp[j].x1=0; bmp[j].y1=0;
				bmp[j].x2=7; bmp[j].x2=7;

				//free(bmp[j].bmp);
				if ((bmp[j].bmp=(uchar *)malloc(SPR8x8_SIZE))==NULL)
					error_msg_pos(i,syntax_list[26],ER_MEM_OUT);

				for (t=0;t<SPR8x8_SIZE;t++)
					bmp[j].bmp[t]=0;
				next_line();
				i+=2;
				/* reads BMP from source code */
				for (t=0;t<S8x8;t++)
				{
					
					tmp[t]=hex_to_b(source[i],source[i+1]);
					i+=2;			
					if ((t+1)%8==0)
					{
						if (source[i]!=NEXT_L_TAG && source[i]!=10)
							error_msg_pos(i,syntax_list[26],ER_BMP);
						i++;
						next_line();
					}					
				}
				
				
				// converts to gxlib sprite
				for (t=0;t<8;t++)
					for (p=0;p<8;p++)
					{
						tmask=(128 >> p);
						if ((tmp[16+t] & tmask)!=0)
						{
							t8x8[t][p]=MASK;
							continue;
						} else t8x8[t][p]=0;
						if ( ((tmp[t] & tmask)!=0) && ((tmp[8+t] & tmask)!=0) )
						{
							t8x8[t][p]=BLACK;
							continue;
						}
						if ((tmp[t] & tmask)!=0)
						{
							t8x8[t][p]=GRAY;
							continue;
						}
						if ((tmp[8+t] & tmask)!=0)
						{
							t8x8[t][p]=DARKGRAY;
							continue;
						}

					}
					makeCode((uchar*)t8x8,8,8,bmp[j].bmp);					
			}
			else /* reads 16x16 bitmap */
			{
				/* sets parametrs for CLSN command: */
				bmp[j].x1=0; bmp[j].y1=0;
				bmp[j].x2=15; bmp[j].x2=15;

				//free(bmp[j].bmp);
				if ((bmp[j].bmp=(uchar *)malloc(SPR16x16_SIZE))==NULL)
					error_msg_pos(i,syntax_list[26],ER_MEM_OUT);

				for (t=0;t<SPR16x16_SIZE;t++)
					bmp[j].bmp[t]=0;
				next_line();
				i+=2;
				/* reads BMP from source code */
				for (t=0;t<S16x16;t++)
				{
					
					tmp[t]=hex_to_b(source[i],source[i+1]);
					i+=2;			
					if ((t+1)%32==0)
					{
						if (source[i]!=NEXT_L_TAG && source[i]!=10)
							error_msg_pos(i,syntax_list[26],ER_BMP);
						i++;
						next_line();
					}					
				}
				
				
				// converts to gxlib sprite
				for (t=0;t<16;t++)
				  for (p=0;p<8;p++)
					for (k=0; k<2; k++)
					{
						tmask=(128 >> p);
						if ((tmp[64+2*t+k] & tmask)!=0)
						{
							t6x6[t][p+k*8]=MASK;
							continue;
						} else t6x6[t][p+k*8]=0;

						if ( ((tmp[2*t+k] & tmask)!=0) && ((tmp[32+2*t+k] & tmask)!=0) )
						{
							t6x6[t][p+k*8]=BLACK;
							continue;
						}
						if ((tmp[2*t+k] & tmask)!=0)
						{
							t6x6[t][p+k*8]=GRAY;
							continue;
						}
						if ((tmp[32+2*t+k] & tmask)!=0)
						{
							t6x6[t][p+k*8]=DARKGRAY;
							continue;
						}

					}					
					makeCode((uchar*)t6x6,16,16,bmp[j].bmp);					
			}
		} else 
		if (source[i]==SYNTAX_TAG && source[i+1]=='D'
			&& source[i+2]=='E' && source[i+3]=='N'
			&& source[i+4]=='D')
		{
			next_line();
			return (i+5); 
		}
		else 
			error_msg_pos(i,syntax_list[24],ER_DATA);
		if (i>=code_size)
			error_msg_pos(0,syntax_list[24],ER_DEND);
	}// main loop


}

void tokenizer(uint size,uint *tok_size){
	/* temporary arrays with names */
	uchar fnct[MAX_FUNCTS][MAX_F_NAME+1];
	uchar ints[MAX_INTS][MAX_NAME+1];
	uchar arrays[MAX_ARRAYS][MAX_NAME+1];
	uchar sprs[MAX_SPRS][MAX_NAME+1];
	uchar strs[MAX_STRS][MAX_NAME+1];
	uchar bmps[MAX_BMPS][MAX_NAME+1];

	/*i  - source index 
	  ix - code index */
	uint i,ix;
	uint dln;
	uchar j;
	uint line=1;
	uint fnct_ac=1;
	uint int_ac=0;	
	uint array_ac=0;
	uint bmp_ac=0;
	uint spr_ac=0;
	uint str_ac=0;
	syntax tmp;
	int spr_v=0;
	int string=0;
	int ok,ok2=0;
	char pom[10];
#if defined DEBUG2
	char key=0;
#endif

	/* reading names of functions and integers */
	fnct[0][0]=15;
	for (i=4;i<size;i++)
	{
	//	if (source[i]== 126) source[i]=INT_TAG;
		/* AFX chars conversion to MLC compatible */
			switch (source[i]){
				case 137://+
					source[i]=ADD_TAG;
				break;
				case 153://-
					source[i]=SUB_TAG;
				break;
				case 169://x
					source[i]=MUL_TAG;
				break;
				case 185:// /
					source[i]=DIV_TAG;
				break;
				case 171:// !			
					source[i]=NOTEQU_TAG;
				break;
				case 17:// !=
					source[i]=NOTEQU_TAG;
				break;
				case 206:// @					
					source[i]=ARRAY_TAG;					
				break;
				case 187:// |					
					source[i]=RES_TAG;					
				break;
				case 14:// -> #					
					source[i]=SYNTAX_TAG;					
				break;
				case 205:// &					
					source[i]=AND_TAG;					
				break;
				case 15:// %					
					source[i]=INT_TAG;					
				break;
				case 168:// ^					
					source[i]=SPR_TAG;					
				break;
				case 10:// [enter] (pc emulation)					
					source[i]=NEXT_L_TAG;					
				break;
				case 126:
					source[i]=STR_TAG;
				break;
			}
		
		if (source[i]==SYNTAX_TAG)
		{
			/* reading functions' names */
			if (syntax_test(i+1,FUNCT_TAG)==0){
				i+=6;
				if (!get_name(i,fnct[fnct_ac++],MAX_F_NAME))
					error_msg(FUNCT_TAG,ER_BADNAME_F,line);
				if (name_test("MAIN",fnct[fnct_ac-1],4)==0)
				{
					if (fnct[0][0]!=15) error_msg(fnct[j],ER_REDEC,line);
					memcpy(fnct[0],fnct[fnct_ac-1],MAX_F_NAME+1);
					fnct_ac--;
				}
				if (fnct_ac>1)
					for (j=0;j<fnct_ac-1;j++)
						if (name_test(fnct[j],fnct[fnct_ac-1],MAX_F_NAME+1)==0)
						{
							error_msg(fnct[j],ER_REDEC,line);
							fnct_ac--;
							break;
						}
				if (fnct_ac>=MAX_FUNCTS) error_msg(ER_TOO_FNCT,fnct[fnct_ac-1],line);
			}			
		}	/* reading integers' names */
		else if (source[i]==INT_TAG){
			i++;
			if (!get_name(i,ints[int_ac++],MAX_NAME))
					error_msg("%",ER_BADNAME_I,line);
				if (int_ac>1)
					for (j=0;j<int_ac-1;j++)
						if (name_test(ints[j],ints[int_ac-1],MAX_NAME)==0)
						{
							int_ac--;
							break;
						}
			if (int_ac>=MAX_INTS) error_msg(ER_TOO_INT,ints[int_ac-1],line);
		}  /* reading BMPs names */
		else if (source[i]==BMP_TAG){
			i++;
			if (!get_name(i,bmps[bmp_ac++],MAX_NAME))
					error_msg("%",ER_BADNAME_I,line);
				if (bmp_ac>1)
					for (j=0;j<bmp_ac-1;j++)
						if (name_test(bmps[j],bmps[bmp_ac-1],MAX_NAME)==0)
						{
							bmp_ac--;
							break;
						}
			if (bmp_ac>=MAX_BMPS) error_msg(ER_TOO_BMP,bmps[bmp_ac-1],line);
		}	/* reading STRs names */
		else if (source[i]==STR_TAG){
			i++;
			if (!get_name(i,strs[str_ac++],MAX_NAME))
					error_msg("%",ER_BADNAME_ST,line);
				if (str_ac>1)
					for (j=0;j<str_ac-1;j++)
						if (name_test(strs[j],strs[str_ac-1],MAX_NAME)==0)
						{
							str_ac--;
							break;
						}
			if (str_ac>=MAX_STRS) error_msg(ER_TOO_STR,strs[str_ac-1],line);
		}	/* raeding SPRs names */
		else if (source[i]==SPR_TAG){
			i++;
			if (!get_name(i,sprs[spr_ac++],MAX_NAME))
					error_msg("%",ER_BADNAME_S,line);
				if (spr_ac>1)
					for (j=0;j<spr_ac-1;j++)
						if (name_test(sprs[j],sprs[spr_ac-1],MAX_NAME)==0)
						{
							spr_ac--;
							break;
						}
			if (spr_ac>=MAX_SPRS) error_msg(ER_TOO_SPR,sprs[spr_ac-1],line);
		}	/* reading arrays' names */
		else if (source[i]==ARRAY_TAG){
			i++;
			if (!get_name(i,arrays[array_ac++],MAX_NAME))
					error_msg("@",ER_BADNAME_A,line);
				if (array_ac>1)
					for (j=0;j<array_ac-1;j++)
						if (name_test(arrays[j],arrays[array_ac-1],MAX_NAME)==0)
						{
							array_ac--;
							break;
						}
			if (array_ac>=MAX_ARRAYS) error_msg(ER_TOO_ARRAY,arrays[array_ac-1],line);
		}
		else
		if (source[i]==NEXT_L_TAG || source[i]==10) line++;
	}
	if (fnct[0][0]==15) error_msg(fnct[j],ER_NO_MAIN,line);
#if defined DEBUG1
	clrscr();
	printf("%u | %u",line, fnct_ac);
	if (getch()==0) getch();
	for (i=0;i<fnct_ac;i++)
		printf("\n%s",fnct[i]);
	if (getch()==0) getch();
	printf("\n%u",int_ac);
	if (getch()==0) getch();
	for (i=0;i<int_ac;i++)
		printf("\n%s",ints[i]);
	if (getch()==0) getch();
#endif

	/* tekenizing syntax and names */
	line = 1;
	ix=0;	
	for (i=4;i<size;i++)
	{
		if (spr_v>0) spr_v--;
		/* reding string "[TEXT]" */
		if (source[i]== STRING_TAG && string==0)
		{
			string=1;
			ok2=0;
		}
		else
		if (source[i]== STRING_TAG && string==1){
			string=0;
			code[ix++]=source[i];
			continue;
		}
		if (string){
			if (source[i]==NEXT_L_TAG || source[i]==10) error_msg(ER_STR_TAG,"",line);
			code[ix++]=source[i];
			continue;
		}				

#if defined DEBUG5
		printf("\n%u: %c | %u",i,source[i], source[i]);
		if (getch()==0) getch();
#endif
		
		/* tekenizing syntax */
		if (source[i]==SYNTAX_TAG){
			get_name(i+1,pom,4);
			for (j=0;j<MAX_SYNTAX;j++)
				if (name_test(pom,syntax_list[j],4)==0)
				{
					code[ix++]=SYNTAX_TAG;
					code[ix++]=j;
					tmp=j;
					break;
				}
				if (j==MAX_SYNTAX) error_msg(ER_SYNTAX,"",line);
			i+=5;
			//if (source[i]==' ') i++;
			
			/* reads the data section */
			if (tmp==DATA)
			{
				code[ix-1]=0;
				code[ix-2]=0;
				ix-=2;
				i=read_data(i+1,&ix,&line,bmps,bmp_ac);
				continue;
			}
			
			if (source[i]==NEXT_L_TAG || source[i]==10)
			{
				line++;
				//if (source[i]==217) i++;
				code[ix++]=NEXT_L_CODE;
				continue;
			}
			

			/* changes FNCT [NAME] to 2 tokens */
			if (tmp==FNCT)
			{
				
				dln=get_name(i+1,pom,MAX_F_NAME);
				for (j=0;j<fnct_ac;j++)
				if (name_test(pom,fnct[j],MAX_F_NAME)==0)
				{
					code[ix++]=j;
					break;
				}	
				if (j==fnct_ac) error_msg(ER_NO_FNCT,"",line);
				i+=dln;				
				continue;
			}	
			/* changes FRUN [NAME] to 2 tokens */
			if (tmp==FRUN)
			{
				dln=get_name(i+1,pom,MAX_F_NAME);
				for (j=0;j<fnct_ac;j++)
				if (name_test(pom,fnct[j],MAX_F_NAME)==0)
				{
					code[ix++]=j;
					break;
				}	
				if (j==fnct_ac) error_msg(ER_NO_FNCT,"",line);
				i+=dln;				
				continue;
			}						

		}	/* changes %[NAME] to 2 tokens */
		else if (source[i]==INT_TAG){
			dln=get_name(i+1,pom,MAX_NAME);
			for (j=0;j<int_ac;j++)
				if (name_test(pom,ints[j],MAX_NAME)==0)
				{
					code[ix++]=INT_TAG;
					code[ix++]=j;
					break;
				}
			if (source[i+dln+1]==' '){ code[ix++]=' '; i+=dln+1;}
			else
				i+=dln;			
		}	/* changes $[NAME] to 2 tokens */
		else if (source[i]==STR_TAG){
			dln=get_name(i+1,pom,MAX_NAME);
			for (j=0;j<str_ac;j++)
				if (name_test(pom,strs[j],MAX_NAME)==0)
				{
					code[ix++]=STR_TAG;
					code[ix++]=j;
					break;
				}
			if (source[i+dln+1]==' '){ code[ix++]=' '; i+=dln+1;}
			else
				i+=dln;			
		}	/* changes ^[NAME] to 2 tokens */
		else if (source[i]==SPR_TAG){
			spr_v=7;
			dln=get_name(i+1,pom,MAX_NAME);
			for (j=0;j<spr_ac;j++)
				if (name_test(pom,sprs[j],MAX_NAME)==0)
				{
					code[ix++]=SPR_TAG;
					code[ix++]=j;
					break;
				}
			if (source[i+dln+1]==' '){ code[ix++]=' '; i+=dln+1;}
			else
				i+=dln;					
		} /* changes [[NAME] to 2 tokens */
		else if (source[i]==BMP_TAG){
			dln=get_name(i+1,pom,MAX_NAME);
			for (j=0;j<bmp_ac;j++)
				if (name_test(pom,bmps[j],MAX_NAME)==0)
				{
					code[ix++]=BMP_TAG;
					code[ix++]=j;
					break;
				}
			if (source[i+dln+1]==' '){ code[ix++]=' '; i+=dln+1;}
			else
				i+=dln;			
		}
		/* changes @[NAME] to 2 tokens */
		else if (source[i]==ARRAY_TAG){
			dln=get_name(i+1,pom,MAX_NAME);
			for (j=0;j<array_ac;j++)
				if (name_test(pom,arrays[j],MAX_NAME)==0)
				{
					code[ix++]=ARRAY_TAG;
					code[ix++]=j;
					break;
				}
			if (source[i+dln+1]==' '){ code[ix++]=' '; i+=dln+1;}
			else
				i+=dln;			
		}
		else
		if (source[i]==NEXT_L_TAG || source[i]==10)
		{
				line++;				
				code[ix++]=NEXT_L_CODE;
		}
		else{
			ok=0;
			for (j=0;j<MAX_OP;j++)
				if (source[i]==op_list[j])
				{
					code[ix++]=op_list[j];
					ok=1;
					break;
				}			
			if (source[i]>='0' && source[i]<='9') {code[ix++]=source[i]-'0'; ok=1; }
			
			
			/* ERROR :*/
			if (ok2>0) ok2--;
			if (ok2==0 && !ok && source[i]==' ')
			{
				ok=1;
				code[ix++]=' ';
				ok2=2;
			}
			if (spr_v>0 && (source[i]=='X' || source[i]=='Y' ||
				source[i]=='B' || source[i]=='M' || 
				source[i]=='V' || source[i]=='D' || source[i]=='P'))
			{
				code[ix++]=source[i];
				ok=1;
			}
			if (!ok) error_msg(ER_COMPIL,"",line);
			
		} 
		(*tok_size)=ix;
	}

#if defined DEBUG2
	//inter(1);
	printf("\n%u | %u\n",line, ix);
	ix=0;	
		do{
			for (i=0;i<6;i++)
				if (ix<(*tok_size))
					printf("%4d| %c | %3d |\n",ix++, code[ix] , code[ix] );
			key=getch();
			if (key==0) key=getch();
		}while (key!=59);
#endif	
}
